# ![Panoramax](https://upload.wikimedia.org/wikipedia/commons/thumb/a/a9/Panoramax.svg/40px-Panoramax.svg.png) Panoramax

__Panoramax__ is a digital resource for sharing and using 📍📷 field photos. Anyone can take photographs of places visible from the public streets and contribute them to the Panoramax database. This data is then freely accessible and reusable by all. More information available at [gitlab.com/panoramax](https://gitlab.com/panoramax) and [panoramax.fr](https://panoramax.fr/).


# 🖼️👀 Web Viewer

This repository only contains __the interactive Web/JS pictures viewer__ of Panoramax.

## Features

The Panoramax viewer is a web JS library which displays pictures and sequences from a Panoramax server, or any STAC API offering geolocated pictures.

![Picture viewer screenshot](https://gitlab.com/panoramax/clients/web-viewer/-/raw/develop/docs/images/screenshot.jpg)

Its features includes:

* Move, zoom, drag pictures
* Travel between pictures in sequences
* Find pictures by location with a mini-map


## Install & run

Our [documentation](https://gitlab.com/panoramax/clients/web-viewer/-/tree/develop/docs) will help you install, configure and use the Panoramax viewer.

If at some point you're lost or need help, you can contact us through [issues](https://gitlab.com/panoramax/clients/web-viewer/-/issues) or by [email](mailto:panoramax@panoramax.fr).


## Contributing

Pull requests are welcome. For major changes, please open an issue first to discuss what you would like to change.

More information about developing is available in [documentation](https://gitlab.com/panoramax/clients/web-viewer/-/tree/develop/docs).


## ⚖️ License

Copyright (c) Panoramax team 2022-2024, [released under MIT license](https://gitlab.com/panoramax/clients/web-viewer/-/blob/develop/LICENSE).
