<a name="Panoramax.components.ui.CopyButton"></a>

## Panoramax.components.ui.CopyButton ⇐ <code>[lit.LitElement](https://lit.dev/docs/api/LitElement/)</code>
**Kind**: static class of <code>Panoramax.components.ui</code>  
**Extends**: <code>[lit.LitElement](https://lit.dev/docs/api/LitElement/)</code>  
**Element**: pnx-copy-button  

* [.CopyButton](#Panoramax.components.ui.CopyButton) ⇐ <code>[lit.LitElement](https://lit.dev/docs/api/LitElement/)</code>
    * [new CopyButton()](#new_Panoramax.components.ui.CopyButton_new)
    * [.properties](#Panoramax.components.ui.CopyButton+properties) : <code>Object</code>

<a name="new_Panoramax.components.ui.CopyButton_new"></a>

### new CopyButton()
Copy Button element allows top copy in clipboard some text.

**Example**  
```html
<pnx-copy-button text="content to copy" ._t=${viewer._t}>
  Copy me !
</pnx-copy-button>
```
<a name="Panoramax.components.ui.CopyButton+properties"></a>

### copyButton.properties : <code>Object</code>
Component properties.

**Kind**: instance property of [<code>CopyButton</code>](#Panoramax.components.ui.CopyButton)  
**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| [text] | <code>string</code> |  | Text to copy in clipboard on click (use either this parameter or input, not both) |
| [input] | <code>input</code> |  | ID of a HTML input field to copy content from in clipboard (use either this parameter or text, not both) |
| [kind] | <code>string</code> | <code>&quot;full&quot;</code> | The style variation of the button (full, outline, flat, superflat, inline, superinline) |
| [size] | <code>string</code> | <code>&quot;md&quot;</code> | The size of the button (sm, md, l, xl, xxl) |
| [unstyled] | <code>boolean</code> | <code>false</code> | Disable all styling (for list group integration) |
| [title] | <code>string</code> |  | Tooltip text displayed when hovering over the button |

