<a name="Panoramax.components.ui.LinkButton"></a>

## Panoramax.components.ui.LinkButton ⇐ <code>[lit.LitElement](https://lit.dev/docs/api/LitElement/)</code>
**Kind**: static class of <code>Panoramax.components.ui</code>  
**Extends**: <code>[lit.LitElement](https://lit.dev/docs/api/LitElement/)</code>  
**Element**: pnx-link-button  

* [.LinkButton](#Panoramax.components.ui.LinkButton) ⇐ <code>[lit.LitElement](https://lit.dev/docs/api/LitElement/)</code>
    * [new LinkButton()](#new_Panoramax.components.ui.LinkButton_new)
    * [.properties](#Panoramax.components.ui.LinkButton+properties) : <code>Object</code>

<a name="new_Panoramax.components.ui.LinkButton_new"></a>

### new LinkButton()
Link Button element displays a HTML `<a>` anchor with a button style.

**Example**  
```html
<pnx-link-button
  title="Redirect to other website"
  kind="outline"
  href="https://panoramax.fr"
  target="_blank"
>
  Click to go on Panoramax
</pnx-link-button>
```
<a name="Panoramax.components.ui.LinkButton+properties"></a>

### linkButton.properties : <code>Object</code>
Component properties.

**Kind**: instance property of [<code>LinkButton</code>](#Panoramax.components.ui.LinkButton)  
**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| [href] | <code>string</code> |  | The URL the button should navigate to when clicked |
| [target] | <code>string</code> |  | Specifies where to open the linked document (e.g., '_blank') |
| [title] | <code>string</code> |  | Tooltip text displayed when hovering over the button |
| [download] | <code>string</code> |  | Indicates if the linked resource should be downloaded |
| [class] | <code>string</code> |  | Custom CSS class for additional styling |
| [kind] | <code>string</code> | <code>&quot;full&quot;</code> | The style variation of the button (full, outline, flat, superflat) |
| [size] | <code>string</code> | <code>&quot;md&quot;</code> | The size of the button (sm, md, l, xl, xxl) |

