<a name="Panoramax.components.ui.Loader"></a>

## Panoramax.components.ui.Loader ⇐ <code>[lit.LitElement](https://lit.dev/docs/api/LitElement/)</code>
**Kind**: static class of <code>Panoramax.components.ui</code>  
**Extends**: <code>[lit.LitElement](https://lit.dev/docs/api/LitElement/)</code>  
**Element**: pnx-loader  

* [.Loader](#Panoramax.components.ui.Loader) ⇐ <code>[lit.LitElement](https://lit.dev/docs/api/LitElement/)</code>
    * [new Loader()](#new_Panoramax.components.ui.Loader_new)
    * [.properties](#Panoramax.components.ui.Loader+properties) : <code>Object</code>
    * [.isVisible()](#Panoramax.components.ui.Loader+isVisible) ⇒ <code>boolean</code>
    * [.dismiss([err], [errMeaningful], [next])](#Panoramax.components.ui.Loader+dismiss)

<a name="new_Panoramax.components.ui.Loader_new"></a>

### new Loader()
Loader component display a full page covering for user waiting.

**Example**  
```html
<pnx-loader ._parent=${this.viewer} />
```
<a name="Panoramax.components.ui.Loader+properties"></a>

### loader.properties : <code>Object</code>
Component properties.

**Kind**: instance property of [<code>Loader</code>](#Panoramax.components.ui.Loader)  
**Properties**

| Name | Type | Default | Description |
| --- | --- | --- | --- |
| [visible] | <code>boolean</code> | <code>true</code> | Is the loader visible to user ? |
| [no-label] | <code>boolean</code> | <code>false</code> | Set to true to avoid loading label display |
| [value] | <code>number</code> |  | Progress bar percentage (0-100) |

<a name="Panoramax.components.ui.Loader+isVisible"></a>

### loader.isVisible() ⇒ <code>boolean</code>
Is the loader currently visible ?

**Kind**: instance method of [<code>Loader</code>](#Panoramax.components.ui.Loader)  
**Returns**: <code>boolean</code> - True if visible  
<a name="Panoramax.components.ui.Loader+dismiss"></a>

### loader.dismiss([err], [errMeaningful], [next])
Dismiss loader, or show error

**Kind**: instance method of [<code>Loader</code>](#Panoramax.components.ui.Loader)  

| Param | Type | Default | Description |
| --- | --- | --- | --- |
| [err] | <code>object</code> | <code></code> | Optional error object to show in browser console |
| [errMeaningful] | <code>str</code> | <code></code> | Optional error message to show to user |
| [next] | <code>fct</code> | <code></code> | Optional function to run after loader dismiss |

