<a name="Panoramax.utils.InitParameters"></a>

## Panoramax.utils.InitParameters
**Kind**: static class of <code>Panoramax.utils</code>  

* [.InitParameters](#Panoramax.utils.InitParameters)
    * [new InitParameters([componentAttrs], [urlParams], [browserStorage])](#new_Panoramax.utils.InitParameters_new)
    * [.getParentInit()](#Panoramax.utils.InitParameters+getParentInit)
    * [.getParentPostInit()](#Panoramax.utils.InitParameters+getParentPostInit)
    * [.getPSVInit()](#Panoramax.utils.InitParameters+getPSVInit)
    * [.getPSVPostInit()](#Panoramax.utils.InitParameters+getPSVPostInit)
    * [.getMapInit()](#Panoramax.utils.InitParameters+getMapInit)
    * [.getMapPostInit()](#Panoramax.utils.InitParameters+getMapPostInit)

<a name="new_Panoramax.utils.InitParameters_new"></a>

### new InitParameters([componentAttrs], [urlParams], [browserStorage])
Merges all URL parameters and component attributes into a single set of coherent settings.


| Param | Type | Description |
| --- | --- | --- |
| [componentAttrs] | <code>object</code> | HTML attributes from parent component |
| [urlParams] | <code>object</code> | Parameters extracted from URL |
| [browserStorage] | <code>object</code> | Parameters read from local/session storage |

<a name="Panoramax.utils.InitParameters+getParentInit"></a>

### initParameters.getParentInit()
Get core component initialization parameters.
They must be passed as soon as possible.

**Kind**: instance method of [<code>InitParameters</code>](#Panoramax.utils.InitParameters)  
<a name="Panoramax.utils.InitParameters+getParentPostInit"></a>

### initParameters.getParentPostInit()
Get core component post-initialization parameters.
They must be passed after first rendering or init.

**Kind**: instance method of [<code>InitParameters</code>](#Panoramax.utils.InitParameters)  
<a name="Panoramax.utils.InitParameters+getPSVInit"></a>

### initParameters.getPSVInit()
Get Photo Sphere Viewer initialization parameters.
They must be passed as soon as possible.

**Kind**: instance method of [<code>InitParameters</code>](#Panoramax.utils.InitParameters)  
<a name="Panoramax.utils.InitParameters+getPSVPostInit"></a>

### initParameters.getPSVPostInit()
Get Photo Sphere Viewer post-initialization parameters.
They must be passed after first rendering or init.

**Kind**: instance method of [<code>InitParameters</code>](#Panoramax.utils.InitParameters)  
<a name="Panoramax.utils.InitParameters+getMapInit"></a>

### initParameters.getMapInit()
Get MapLibre GL initialization parameters.
They must be passed as soon as possible.

**Kind**: instance method of [<code>InitParameters</code>](#Panoramax.utils.InitParameters)  
<a name="Panoramax.utils.InitParameters+getMapPostInit"></a>

### initParameters.getMapPostInit()
Get MapLibre GL post-initialization parameters.
They must be passed after first rendering or init.

**Kind**: instance method of [<code>InitParameters</code>](#Panoramax.utils.InitParameters)  
